
# Audiomatic

Companion gem to Audiomatic app, provides drop in integration to audio processing services. It provides method which simplyfly sending request to audiomatic.  


## Installation

Add this line to your application's Gemfile:

```ruby
gem 'Audiomatic'
```

And then execute:

    $ bundle

Or install it yourself as:

    $ gem install Audiomatic

## Usage
### Audiomatic configuration 

For heroku users, configuration is really easy.Just install Audiomatic (url) plugin and paste code below to `config/initializer/audiomatic_config.rb`: 

```ruby
Audiomatic.config do |c|
  c.processor_host = ENV['AUDIOMATIC_URL']
  c.audiomatic_secret = ENV['AUDIOMATIC_SHARED_SECRET']
end
```
otherwise you should provide your unique URL and NeutrinoAudiomatic secret:

```ruby
Audiomatic.config do |c|
  c.processor_host = "https://login:password@audiomatic.radiokitapp.org/api/
  process"
  c.audiomatic_secret = ENV['AUDIOMATIC_SHARED_SECRET']
end
```

### Sending request

Audiomatic_gem provides method to communicate with Audiomatic which simplifies formation request body and senting it. Those methods calls like processors which audiomatic provides. To use it, you need url to file which you want to analyze and endpoint which gets audiomatic answer. Example: 


```ruby
    file_url = "http://mysite.com/path/to/file.mp3"
    callback_url = "http://mysite.com/callbacks/file.mp3"

    Audiomatic::Processor.replaygain(file_url, callback_url: callback_url)

```    
This method return information about success or error during sending your request to Audiomatic server. 

avalible method:
* Audiomatic::Processor.duration
* Audiomatic::Processor.replaygain
* Audiomatic::Processor.tags
* Audiomatic::Processor.webbrowser
* Audiomatic::Processor.waveform

Processing your data can take a while, a speciality a large files. Thats why Audiomatic works asynchronously - your results will arive in seperate request. You have to provide your onw endpoint to get the Audiomatic answer.

Audimatic sends answer in json 


### Audiomatic processors and results

<table>
  <tr>
    <th>Processors</th>
    <th>Results</th>
    <th>Format</th>
  </tr>
  <tr>
    <td>duration</td>
    <td>duration</td>
    <td>Integer [ms] </td>
  </tr>
  <tr>
    <td>tags</td>
    <td>all-tags-you-set</td>
    <td>String </td>
  <tr>
    <td>replaygain</td>
    <td>replaygain-track-peak</td>
    <td>fload [dB] </td>
  </tr>
  <tr>
    <td></td>
    <td>replaygain-track-gain</td>
    <td>fload [dB]  </td>
  </tr>
  <tr>
    <td></td>
    <td>replaygain-reference-level</td>
    <td>fload [dB] </td>
  </tr>

</table>


## License

The gem is available as open source under the terms of the [MIT License](http://opensource.org/licenses/MIT).

